/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>

/* poke value for character set */
#define UPPER_CASE 21

/* poke values for colors */
#define C64_BLUE 6
#define C64_LBLUE 14

int _crtmode = 0;
char _crtset[2]; /* work buffer */

crtmode(prevmode)
int prevmode;
{
	/* to get crtmode set prevmode to - 1 */
	/* to set crtmode to current mode set prevmode to a valid value 0-2 */
	if (prevmode == 0 || prevmode == 1 || prevmode == 2) _crtmode = prevmode;
	return _crtmode;
}

setcrtmode(mode)
int mode;
{

   if (mode < 1 || mode > 2)mode = 0;
   switch(mode)
   {
	   case 0: if (_crtmode == 0)break; /* do not reset if already set */

            /* if setting to textmode 0 from graphics mode 1 or 2 */
            /* turn off graphics */
			blockmv(&_crtset[0],scrsetup,1);
			_crtset[0] = (_crtset[0] & 223);
			blockmv(scrsetup,&_crtset[0],1);

            /* make sure the upper case characters */
            /* are loaded by default */
			_crtset[0] = UPPER_CASE;
			blockmv(memsetup,&_crtset[0],1);

            /* if setting from multicolor mode 2 to textmode 0 */
            if (_crtmode == 2) {
			    /* turn off multicolor mode */
			    blockmv(&_crtset[0],multimode,1);
			    _crtset[0] = (_crtset[0] & 239);
			    blockmv(multimode,&_crtset[0],1);
			}

            /* set the border and background colors to defaults */
			_crtset[0] = C64_LBLUE;
			_crtset[1] = C64_BLUE;
			blockmv(bordercolor,_crtset,2);
			break;

	 case 1:
	        if (_crtmode == 1) break; /* do not reset if already set */
    		if (_crtmode == 2) {
				/* if changing to hires mode 1 fom multicolor mode 2 */
				/* turn off multicolor mode */
				blockmv(&_crtset[0],multimode,1);
				_crtset[0] = (_crtset[0] & 239);
				blockmv(multimode,&_crtset[0],1);
				break;
			}
			/* if changing from text mode 0 to graphics modes 1 or 2 */
            /* this falls through to the common code block below */
	 case 2:
	        if (_crtmode == 2) break; /* do not reset if already set */
	        if (_crtmode == 0) {
				/* changing from text mode 0 to graphics modes 1 or 2 */
				/* turn on hires mode */
			    blockmv(&_crtset[0],memsetup,1);
			    _crtset[0] = (_crtset[0] | 8);
			    blockmv(memsetup,&_crtset[0],1);

			    blockmv(&_crtset[0],scrsetup,1);
			    _crtset[0] = (_crtset[0] | 32);
                blockmv(scrsetup,&_crtset[0],1);
			}
			/* if changing to hires mode 1 from text mode 0 */
			/* we are done */
			if (mode == 1)break;


			/* if changing to multicolor mode 2 from mode 0 or 1 */
			/* second step required for multicolor graphics mode */
			blockmv(&_crtset[0],multimode,1);
			_crtset[0] = (_crtset[0] | 16);
			blockmv(multimode,&_crtset[0],1);
			break;

   }

   _crtmode = mode;
   return mode;
}