/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>

/* the following function fills a color block with a fill pattern */
/* i wrote it to work with solid fills if called from fbox */
/* however a fill pattern could also be applied if you wish */
/* to build your own patterns in an 8 bit x 8 byte block */

/* remembering of course that patterns used in multicolor mode
   are 4 pixels wide x 8 rasters deep, and patterns used in
   hires mode are 8 pixels wide x 8 rasters deep.

   the obvious limitation is that being a block oriented
   flood fill, the contents of the display will be overwritten with
   whatever the fill happens to be rather than doing any meaningful
   area fills, and the fill is block oriented so coordinates are
   taken in row and column rather than pixels and rasters. */

fchar(fch,row,column,color1,color2,color3)
char *fch;
int row, column,color1,color2,color3;
{
	int offset, idx;
	int voff;

	/* screen is a matrix of 25 x 40 columns */
	if (row < 0 || row > 25) row = 0;
	if (column < 0 || column > 40)column = 0;
	if (color1 < 0 || color1 > 15 || color2 < 0 || color2 > 15) {
	  color1 = -1;
	  color2 = -1;
	  color3 = -1;
	}
	else {
	   color1 = (color1 | (color2 << 4));

	}
	if (color3 < 0 || color3 > 15)color3 = -1;

	offset = (row * 320) + (column * 8);
	voff = (row * 40) + column;


	/* put fill character on screen and increment offset */
	for (idx = 0; idx < 8; idx++) {
		bmp[offset] = fch[idx];
		offset++;
	}
	if (color1 != -1)vram[voff] = color1;
	if (color3 != -1)cram[voff] = color3;


}

