/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>


/* the following function reads a logical pixel on the C64.
   It handles both of the standard videomodes;
   HIRES and Multicolor. Since HIRES mode supports 2 colors, valid
   color values are either 0 or 1.Multicolor mode (like the CGA on the
   IBM-PC) has four colors; 0-3. */

getpixel(x,y,mode)
int x, y, mode;
{

    /* mode 2 is MultiColor mode  160 pixels x 200 rasters x 1 bit */
    /* mode 1 is HIRES mode 320 pixels x 200 rasters x 2 bits */

 	int color, offset, row, column, temp;

/*
 	bmp = (char *)8192;
	vram = (char *)1024;
	cram = (char *)55296;

*/
    /* we need to locate the 8 bit x 8 bit block that x and y refer to */
    /* if in multi-color mode this is expressed in a 4 pixel x 8 bit block */

    if (mode == 2) {
		/* if we are in multicolor mode */
	    /* the matrix will be 4 pixels wide x 8 rasters deep */
		row = y/8;
		column = x/4;
		y = y - (row * 8);
		offset = (row * 320) + (column * 8) + y;

		/* determine the pixel location in the byte */
		x = 6 - ((x%4) * 2);

		temp = bmp[offset];
		color = (temp >> x) & 3;


	}
	else {
		/* if we are in hires mode the matrix will be 8 pixels wide x 8 rasters deep */
    	row = y/8;
    	column = x/8;
        y = y - (row * 8);
	    offset = (row * 320) + (column * 8) + y;

        /* determine the pixel location in the byte */
        x = 7 - (x - (column * 8));

        temp = bmp[offset];
		color = (temp >> x) & 1;
   	}

   	return (color);

}