/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>

/* the following function plots the 8x8 embedded font in static memory */
/* note: do not do stack arithmetic or you may overflow when calling this */
/* instead precalculate your coordinates before making this call */
pfont(ptr,row,column,color1,color2,color3)
char *ptr;
int row, column,color1,color2,color3;
{
	int c, offset, idx, jdx, fdx;
	int voff;

	/* plots from top left */

    /* screen is a matrix of 25 x 40 columns */
	if (row < 0 || row > 25) row = 0;
	if (column < 0 || column > 40)column = 0;
    if (color1 < 0 || color1 > 15 || color2 < 0 || color2 > 15) {
	  color1 = -1;
	  color2 = -1;
	  color3 = -1;
	}
	else {
	   color1 = (color1 | (color2 << 4));

	}
	if (color3 < 0 || color3 > 15)color3 = -1;

	offset = (row * 320) + (column * 8);
    voff = (row * 40) + column;

	for (jdx = 0; ptr[jdx]!=0;jdx++) {
	   c = ptr[jdx] & 0x7f; /* get low ascii value of char */
	   fdx = c * 8; /* calculate offset into font */
	   /* put font on screen and increment both offsets */
	   for (idx = 0; idx < 8; idx++) {
	        bmp[offset] = ramfont[fdx];
	        fdx ++;   /* advance through character bitmap */
	        offset++; /* advance through screen - running count */
	   }
	   if (color1 != -1)vram[voff] = color1;
	   if (color3 != -1)cram[voff] = color3;
	   voff++;
    }


}
