/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>


/* the following function plots a pixel on the C64 using the currently
   selected palette. It handles both of the standard videomodes;
   HIRES and Multicolor. Since HIRES mode supports 2 colors, valid
   color values are either 0 or 1.Multicolor mode (like the CGA on the
   IBM-PC) has four colors; 0-3. */

plot(x,y,color,mode)
int x, y, color, mode;
{

    /* mode 2 is MultiColor mode  160 pixels x 200 rasters x 1 bit */
    /* mode 1 is HIRES mode 320 pixels x 200 rasters x 2 bits */

 	int c, ch, offset, row, column, temp;

/*
 	bmp = (char *)8192;
	vram = (char *)1024;
	cram = (char *)55296;

*/
    /* we need to locate the 8 bit x 8 bit block that x and y refer to */
    /* if in multi-color mode this is expressed in a 4 pixel x 8 bit block */

    /* I am simplifying this by using an inclusive or */
    /* get rid of whatever color was already there */
    /* unless we are plotting a white pixel */

    if (mode == 2) {
		/* if we are in multicolor mode */
	    /* the matrix will be 4 pixels wide x 8 rasters deep */
		row = y/8;
		column = x/4;
		y = y - (row * 8);
		offset = (row * 320) + (column * 8) + y;

		/* determine the pixel location in the byte */
		x = 6 - ((x%4) * 2);
		c = (3<<x);
		if (color == 3) {
		   /* set the character at the raster */
		   temp = bmp[offset];
		   bmp[offset] = temp | c;
		}
		else {
		   /* get the character at the raster */
		   /* get rid of whatever color was already there */
		   temp = bmp[offset];

		   ch = (temp ^0xff) | c; /* reverse and unset pixel */
		   /* revert and set */
		   if (color == 1 || color == 2) bmp[offset] = (ch^0xff) | (color << x);
		   else bmp[offset] = (ch^0xff); /* revert */
		}

	}
	else {
		/* if we are in hires mode the matrix will be 8 pixels wide x 8 rasters deep */
    	row = y/8;
    	column = x/8;
        y = y - (row * 8);
	    offset = (row * 320) + (column * 8) + y;

        /* determine the pixel location in the byte */
        x = 7 - (x - (column * 8));
        c = (1 << x);
	    /* set the character at the raster */
	    if (color == 1) {
			temp = bmp[offset];
		    bmp[offset] = (temp | c);

		}
        else {
			/* get the character at the raster */
			/* get rid of whatever color was already there */
			temp = bmp[offset];
			ch = (temp ^0xff) | c; /* reverse and unset pixel */
			bmp[offset] = (ch^0xff); /* revert */

		}
	}

}