/* Copyright (C) Bill Buckels 2008 */

#include <poke.h>

scr_clear()
{
	putchar(147); /* clear screen and home cursor */
}


scr_upper()
{
	putchar(142); /* reset from mixed case mode */
}

scr_mixed()
{
	putchar(14);  /* put the C64 into mixed case mode */
}

scr_reverse(x)
int x;
{
	if (x !=0)
	  putchar(18);
	else
	  putchar(146);
}

scr_back(bk, bor)
int bk, bor;
{
	if (bk > -1 && bk < 16) poke[53281] = bk;
	if (bor > -1 && bor < 16) poke[53280] = bor;
}


char _txtc[16] = {
144, 5, 28, 159, 156, 30, 31, 158,
129, 149, 150, 151, 152, 153, 154, 155};

/* uses c64 colors 0-15 */
scr_txtcolor(x)
int x;
{
    if (x > -1 && x < 16)putchar(_txtc[x]);
}

scr_reset()
{
	putchar(142); /* reset from mixed case mode */
	putchar(154); /* set text color to light blue */
	poke[53281] = 6; /* set background to blue */
	poke[53280] = 14; /* set border to lblue */
	putchar(147); /* clear screen and home cursor */

}

/* move cursor on screen */
scr_up()
{
	putchar(145);
}

scr_dn()
{
	putchar(17);
}

scr_lt()
{
	putchar(157);
}

scr_rt()
{
	putchar(29);
}

/* position cursor on text screen */
scr_curs(row, col)
int row, col;
{
	int r, c;

	if (row < 0 || row > 24) row = 0;
	if (col < 0 || col > 39) col = 0;

	r = currow[0];
    c = curcol[0];

    /* position to row first */
    if (row != r) {
	    if (r < row) {
		    while (row != r) {
			     putchar(17);  /* down */
			     r++;
			}
		}
		else {
			while (row != r ) {
			    putchar(145); /* up */
			    r--;
			}
		}
	}
	/* now position to column */
    if (col != c) {
	    if (c < col) {
		    while (col != c) {
			     putchar(29);  /* right */
			     c++;
			}
		}
		else {
			while (col != c ) {
			    putchar(157); /* left */
			    c--;
			}
		}
	}
}

/* home cursor without clearing screen */
scr_home()
{
	scr_curs(-1,-1);
}

