/*	Copyright (c) 1982 by Manx Software Systems	*/
/*	Copyright (c) 1982 by Jim Goodnow II		*/

/*  fixups (C) Copyright Bill Buckels 2008. All Rights Reserved. */
#define CPMTEXT 1

#define	AR_MAGIC	0x3c59

#ifdef CPMTEXT
#include <string.h>
#define alloc malloc
#define blockmv(x,y,z) movblock(y,x,z)
#endif

/* BB */
char *alloc();
char *index();

struct arhead {
unsigned ar_magic;
long ar_len;
};

struct arrec {
char ar_name[31];
char ar_mode;
long ar_size;
};

struct arhead head = {AR_MAGIC, 6L};
int afd;
int verbose = 0;
int newflg = 0, list = 0, addflg = 0;
int extract = 0;
int mode = 6;
/* int errno; */
struct arrec arch;

long lseek();

main(argc, argv)
register int argc;
register char **argv;
{
	register int i, j, nfiles = 0;
	register char *outnam = 0;
	register char *cp;
	char *files[500];

	if (argc < 3)
		usage();
	while (--argc) {
		if ((*++argv)[0] == '-') {
			cp = *argv;
			while (*++cp) {
				switch(tolower(*cp)) {
				case 'f':
					argc--;
					if ((i=open(*++argv, 0)) < 0)
						quit("Error opening param file \"%s\".\n", *argv);
					nfiles += getfiles(i, files+nfiles);
					break;
				case 'o':
					outnam = *++argv;
					argc--;
					break;
				case 'c':
					newflg++;
					break;
				case 'l':
					list++;
					break;
				case 'v':
					verbose++;
					break;
				case 'x':
					extract++;
					break;
				case 'a':
					addflg++;
					break;
				default:
					printf("Bad option '%c' ignored.\n", *argv[1]);
					break;
				}
			}
		}
		else
			files[nfiles++] = *argv;
	}
	if (outnam == 0)
		quit("No output file specified.\n");
	if (list + extract + addflg != 1)
		quit("Need at least one and only one of lxa.\n");
	if (newflg) {
		afd = creat(outnam, 4);
		if (afd < 0)
			quit("Can't creat output file \"%s\".\n", outnam);
		write(afd, &head, 6);
		close(afd);
	}
	afd = open(outnam, addflg?2:0);
	if (afd < 0)
		quit("Can't open %s file <%s>.\n", addflg?"output":"input", outnam);
	if (read(afd, &head, sizeof(head)) != sizeof(head))
		quit("Error reading output file.\n");
	if (head.ar_magic != AR_MAGIC)
		quit("Output file is not an archive file.\n");

#ifdef CPMTEXT
	for (i=0;i<nfiles;i++)
		for (cp=files[i];*cp;cp++)
			*cp = tolower(*cp);
#endif
	if (list)
		data(files, nfiles);
	else if (addflg)
		add(files, nfiles);
	else if (extract)
		ext(files, nfiles);

	lseek(afd, 0L, 0);
	write(afd, &head, sizeof(head));
	close(afd);
	exit(0);
}

ext(file, nfiles)
register char **file;
register int nfiles;
{
	register int i, fd, flg = 0;
	long len;
	char buf[8192];

	if (nfiles == 0)
		flg = nfiles = 1;
	lseek(afd, 6L, 0);
	while (lseek(afd, 0L, 1) < head.ar_len) {
		read(afd, &arch, sizeof(arch));
		if (arch.ar_name[0]) {
			fd = -1;
			for (i=0;i<nfiles;i++) {
				if (flg || strcmp(arch.ar_name, file[i]) == 0) {
					if (verbose)
						printf("x - %s\n", arch.ar_name);
					fd = creat(arch.ar_name, arch.ar_mode);
					if (fd < 0)
						quit("Error creating file - \"%s\".\n", arch.ar_name);
					len = arch.ar_size;
					while (len) {
						if (len < 8192)
							i = len;
						else
							i = 8192;
						i = read(afd, buf, i);
						if (i <= 0)
							break;
#ifdef CPMTEXT
						cpmwr(fd, buf, i);
#else
						write(fd, buf, i);
#endif
						len -= i;
					}
					close(fd);
					break;
				}
			}
		}
		if (fd == -1)
		lseek(afd, arch.ar_size, 1);
	}
}

data(file, nfiles)
register char **file;
register int nfiles;
{
	register int i;

	lseek(afd, 6L, 0);
	while (lseek(afd, 0L, 1) < head.ar_len) {
		read(afd, &arch, sizeof(arch));
		lseek(afd, arch.ar_size, 1);
		if (arch.ar_name[0] == 0)
			continue;
		if (nfiles == 0)
			printf("%6ld  %s\n", arch.ar_size, arch.ar_name);
		else {
			for (i=0;i<nfiles;i++)
				if (strcmp(arch.ar_name, file[i]) == 0) {
					printf("%6ld  %s\n", arch.ar_size, arch.ar_name);
					break;
				}
		}
	}
}

add(file, nfiles)
register char **file;
register int nfiles;
{
	register int fd, i, j;
	register char *cp;
	char buf[8192];
	extern int errno;

	for (i=0;i<nfiles;i++) {
		if ((fd=open(file[i], 0)) < 0) {
			printf("Cannot open file \"%s\".\n", file[i]);
			return;
		}
		if (verbose)
			printf("a - %s\n", file[i]);
		cp = index(file[i], ',');
		if (cp)
			*cp = 0;
		strcpy(arch.ar_name, file[i]);
		arch.ar_size = 0;
#ifdef CPMTEXT
		arch.ar_mode = 0;
#else
		arch.ar_mode = ioctl(fd, 2);
#endif
		lseek(afd, head.ar_len, 0);
		write(afd, &arch, sizeof(arch));
		for (;;) {
#ifdef CPMTEXT
			j = cmprd(fd, buf, 8192);
#else
			j = read(fd, buf, 8192);
#endif
			if (j <= 0)
				break;
			arch.ar_size += j;
			write(afd, buf, j);
		}
		head.ar_len = lseek(afd, 0L, 1);
		lseek(afd, -(arch.ar_size+sizeof(arch)), 1);
		write(afd, &arch, sizeof(arch));
		close(fd);
	}
}

getfiles(fd, files)
int fd;
char *files[];
{
	register char *cp, *ep, *np = 0;
	register unsigned next = 0;
	register int c;
	char buf[120];
	char inbuf[30];

	cp = ep;
	for (;;) {
		if (cp == ep) {
			if ((c = read(fd, buf, 120)) <= 0)
				break;
			cp = buf;
			ep = buf + c;
		}
		if (np == 0) {
			while (cp < ep && ((c=*cp)==' ' || c=='\r' || c=='\t' || c=='\n'))
				cp++;
			if (cp == ep)
				continue;
			np = inbuf;
		}
		while (cp < ep && (c=*cp)!=' ' && c!='\r' && c!='\t' && c!='\n')
			*np++ = *cp++;
		if (cp == ep)
			continue;
		*np++ = 0;
		if ((np = alloc(np - inbuf)) == 0)
			quit("Out of memory!\n");
		strcpy(np, inbuf);
		files[next++] = np;
		np = 0;
	}
	close(fd);
	return(next);
}

usage()
{
	quit("usage: arch -[clvxa] -o library [fil1] [fil2] ...\n");
}

quit(str, a1, a2, a3, a4 ,a5)
char *str;
{
	printf(str, a1, a2, a3, a4, a5);
	exit(1);
}

printf(str, args)
char *str, *args;
{
	int putch();

	format(putch, str, &args);
}

putch(c)
int c;
{
#ifdef CPMTEXT
	if (c == '\n')
		write(1, "\r", 1);
#endif
	write(1, &c, 1);
}

#ifdef CPMTEXT
cmprd(fd, buf, cnt)
int fd, cnt;
char *buf;
{
	register char *cp;

	if ((cnt = read(fd, buf, cnt)) <= 0)
		return(cnt);
	for (cp=buf;cp<buf+cnt;cp++) {
		if (*cp == '\n') {
			blockmv(cp, cp+1, cnt - (cp - buf));
			--cnt;
		}
		if (*cp == 0x1a) {		/* control Z */
			cnt = cp - buf;
			break;
		}
	}
	return(cnt);
}

cpmwr(fd, buf, cnt)
int fd, cnt;
char *buf;
{
	register char *cp;

	for (cp=buf;cp<buf+cnt;cp++) {
		write(fd, cp, 1);
		if (*cp == '\r')
			write(fd, "\n", 1);
	}
	return(cnt);
}
#endif
