/*	Copyright (c) 1983 by Manx Software Systems, Inc.	*/

typedef long val_t, uval_t;

format(putsub, fmt, args)
register int (*putsub)(); register char *fmt; register unsigned *args;
{
	register char c;
	register char *cp, *ep;
	register unsigned i, k;
	unsigned maxwidth, width;
	char rj, fillc;
	val_t value;
	char s[40];
#ifdef FLOAT
	double dval;
#endif

	fmt--;
	ep = s+14;
	while ( c = *++fmt ) {
		if ( c == '%' ) {
			*ep = 0;
			rj = 1;
			fillc = ' ';
			maxwidth = 0x7fff;
			if ( (c = *(fmt+1)) == '-' ) {
				rj = 0;
				c = *++fmt;
			}
			if ( c == '0' )
				fillc = '0';
			for ( width = 0 ; (c = *++fmt) >= '0' && c <= '9' ; )
				width = width*10 + c - '0';
			if ( c == '.' ) {
				for ( maxwidth = 0 ; (c = *++fmt) >= '0' && c <= '9' ; )
					maxwidth = maxwidth*10 + c - '0';
			}
			if (c == 'l') {
				c = *++fmt;
				value = *((long *)args)++;
			} else if (c == 'd')
				value = (int)*args++;
#ifdef FLOAT
			else if (c == 'e' || c == 'f' || c == 'g')
				dval = *((double *)args)++;
#endif
			else
				value = *args++;

			switch ( c ) {
			case 'o':
				cp = uconvert(value, 8, ep);
				break;
			case 'd':
				if ( value < 0 ) {
					cp = convert(-value, 10, ep);
					*--cp = '-';
				} else
					cp = convert(value, 10, ep);
				break;
			case 'u':
				cp = uconvert((val_t)(uval_t)value, 10, ep);
				break;
			case 'x':
				cp = uconvert(value, 16, ep);
				break;
			case 's':
				i = strlen(cp = (char *)(unsigned)value);
				goto havelen;
#ifdef FLOAT
			case 'e':
			case 'f':
				ftoa(dval, s, maxwidth==0x7fff?6:maxwidth, c=='e'?0:1);
				i = strlen(cp = s);
				maxwidth = 200;
				goto havelen;
#endif

			case 'c':
				c = value;
				*(cp = ep-1) = c;
				break;
			default:
				*(cp = ep-1) = c;
				args--;
				break;
			}

			i = ep - cp;
		havelen:
			if ( i > maxwidth )
				i = maxwidth;
			
			if ( rj ) {
				while ( width-- > i )
					(*putsub)(fillc);
			}
			for ( k = 0 ; *cp && k < maxwidth ; ++k )
				(*putsub)(*cp++);
			
			if ( !rj ) {
				while ( width-- > i )
					(*putsub)(' ');
			}
		} else
			(*putsub)(c);
	}
}

static char digits[]="0123456789abcdef";

static
convert(n, base, s)
register int base; register char *s; register uval_t n;
{
	do {
		*--s = digits[(int)(n%base)];
	} while ( (n /= base) != 0 );
	return s;
}

static
uconvert(n, base, s)
register int base; register char *s; long n;
{
	register int t;

	if (n < 0) {
		t = (int)n&1;
		n = (n>>1)&0x7fffffff;
		*--s = digits[((int)(n%(base>>1))<<1)+t];
		n /= base>>1;
	}
	return convert(n,base,s);
}

