/*	Copyright (C) 1984 by Manx Software Systems, Inc.		*/

#include	"xfer.h"

main(argc, argv)
int argc;
char **argv;
{
	char *hname = 0, *tname = 0;
	char *cp, buf[40];

	print("\nFILE TRANSFER UTILITY V1.4c - MASTER");
	print("\n(C) 1984 Manx Software Systems, Inc.\n");
	Master = 1;
	cinit(MBAUD);
#ifdef DELAY
	Delay = DELAY;
#else
	Delay = 0;
#endif

	Sendflg = 1;

	while (--argc) {
		cp = *++argv;
		if (*cp == '-') {
			while (*++cp) {
				switch(tolower(*cp)) {
				case 'p':
					Progflg = 1;
					break;
				case 'a':
					Asciiflg = 1;
					break;
				case 'r':
					Sendflg = 0;
					break;
				case 't':
					if (tname)
						fatal("Only one \"-t\" option allowed.\n");
					if (--argc == 0)
						fatal("\"-t\" without filename.\n");
					tname = *++argv;
					if (strcmp(tname, "?") == 0) {
						print("-t name?");
						gets(buf);
						tname = buf;
					}
					break;
				}
			}
		}
		else {
			if (hname)
				fatal("Only one file may be specified.\n");
			hname = cp;
			if (tname == 0)
				tname = hname;
		}
	}
	if (hname == 0)
		usage();
	xfer(hname, tname);
}

xfer(hname, tname)
char *hname, *tname;
{
	int i;
	char *cp;
	char buf[128];

	cp = buf;
	*cp++ = Sendflg;
	*cp++ = Asciiflg;
	*cp++ = Progflg;
	while (*cp++ = tolower(*tname++))
		;
	if ((i=psend(buf, START, 0, cp-buf)) == -1) {
		print("Unable to start communication.\n");
		abort(1);
		exit(1);
	}
	if (i == -2) {
		print("Slave aborted.\n");
		exit(1);
	}
	if (Sendflg)
		sendfile(hname);
	else
		recvfile(hname);
}

usage()
{
	fatal("usage: xfer [-par] [-t target_name] host_name\n");
}

fatal(msg, a1, a2, a3)
char *msg;
{
	print(msg, a1, a2, a3);
	exit(1);
}

