/* curlib.c (C) Copyright Bill Buckels 2008 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char curbuf[1000];

FILE *fp=NULL, *fp2=NULL, *fp3=NULL, *fp4=NULL;

main(int argc, char *argv[])
{
	int ctr = 0,c;

/* this is a special purpose utility for
   creating cursor libraries that are embeded into
   aztec C programs instead of vram using up to 3 fragments
   or files named on the command line.

   the caveat is that you keep the maximum size
   of all 3 files to 1000 bytes total.

   You will generally want to create a cursor library using
   a left and right hand cursor and a musical note to indicate
   whether sound is in use or not.

   */

   if (argc < 2) {
      puts("Usage is \"Curlib [frag1] [frag2] [frag3]\"");
      exit(1);
   }


   fp = fopen("cursor.vhi","wb");
   fputc(0,fp);
   fputc(0x1C,fp);

   fp2 = fopen(argv[1],"rb");
   if (argc > 2) fp3 = fopen(argv[2],"rb");
   if (argc > 3) fp4 = fopen(argv[3],"rb");


   if (NULL != fp2) {
       while ((c = fgetc(fp2))!=EOF) {
		   if (ctr < 1000)fputc(c,fp);
		   ctr++;
	   }

   }
   if (NULL != fp3) {
       while ((c = fgetc(fp3))!=EOF) {
		   if (ctr < 1000)fputc(c,fp);
		   ctr++;
	   }

   }
   if (NULL != fp4) {
       while ((c = fgetc(fp4))!=EOF) {
		   if (ctr < 1000)fputc(c,fp);
		   ctr++;
	   }

   }

   while (ctr < 1000) {
	  fputc(0,fp);
	  ctr++;
   }


   if (NULL!=fp)fclose(fp);
   if (NULL!=fp2)fclose(fp2);
   if (NULL!=fp3)fclose(fp3);
   if (NULL!=fp4)fclose(fp4);

   exit(0);

}